Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- Debugging
- Interface
- Lit
- Logic
- MatchAnalysis
- MatchApproximation
- MatchCodeGen
- MatchCps
- MatchOptimization
- MatchTranslation
- MatchTreeMaking
- MatchWarnings
- PatternExpansion
- PatternMatching
- PatternMatchingStats
- ScalaLogic
- Solving
- TreeAndTypeAnalysis

t

scala.tools.nsc.transform.patmat

# MatchTreeMaking

###

#### trait MatchTreeMaking extends MatchCodeGen with Debugging

Translate our IR (TreeMakers) into actual Scala Trees using the factory methods in MatchCodeGen.

The IR is mostly concerned with sequencing, substitution, and rendering all necessary conditions, mostly agnostic to whether we're in optimized/pure (virtualized) mode.

Source
  MatchTreeMaking.scala

Linear Supertypes
Debugging, MatchCodeGen, Interface, TreeDSL, AnyRef, Any
Known Subclasses
patmat, MatchAnalysis, MatchApproximation, MatchOptimization, PatternMatching
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MatchTreeMaking
2. Debugging
3. MatchCodeGen
4. Interface
5. TreeDSL
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Type Members

1.  trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface
2.  trait TypedSubstitution extends MatchMonadInterface
   Definition Classes
     Interface
3.  trait CodegenCore extends MatchMonadInterface
   Definition Classes
     MatchCodeGen
4.  trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface
   Definition Classes
     MatchCodeGen
5.  final case class Suppression(suppressExhaustive: Boolean, suppressUnreachable: Boolean) extends Product with Serializable
6.  trait TreeMakers extends TypedSubstitution with CodegenCore

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     Debugging

### Concrete Value Members

1.  object CODE
   Definition Classes
     TreeDSL
2.  object debug
   Definition Classes
     Debugging
3.  object vpmName
   Definition Classes
     Interface
4.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
5.  final def ##: Int
   Definition Classes
     AnyRef → Any
6.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from MatchTreeMaking toany2stringadd[MatchTreeMaking] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
7.  def ->[B](y: B): (MatchTreeMaking, B)
   Implicit
     This member is added by an implicit conversion from MatchTreeMaking toArrowAssoc[MatchTreeMaking] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
8.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
9.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
10.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  final def dealiasWiden(tp: Global.Type): Global.Type
    Attributes
      protected
    Definition Classes
      Interface
12.  def ensuring(cond: (MatchTreeMaking) => Boolean, msg: => Any): MatchTreeMaking
    Implicit
      This member is added by an implicit conversion from MatchTreeMaking toEnsuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: (MatchTreeMaking) => Boolean): MatchTreeMaking
    Implicit
      This member is added by an implicit conversion from MatchTreeMaking toEnsuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean, msg: => Any): MatchTreeMaking
    Implicit
      This member is added by an implicit conversion from MatchTreeMaking toEnsuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean): MatchTreeMaking
    Implicit
      This member is added by an implicit conversion from MatchTreeMaking toEnsuring[MatchTreeMaking] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
17.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
18.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
19.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from MatchTreeMaking toStringFormat[MatchTreeMaking] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
20.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
21.  final def hasStableSymbol(p: Global.Tree): Boolean
    Attributes
      protected
    Definition Classes
      Interface
22.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
23.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
24.  final def mkFALSE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
25.  final def mkTRUE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
29.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
30.  def toString(): String
    Definition Classes
      AnyRef → Any
31.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
32.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
33.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
34.  object Suppression extends java.io.Serializable

### Deprecated Value Members

1.  def →[B](y: B): (MatchTreeMaking, B)
   Implicit
     This member is added by an implicit conversion from MatchTreeMaking toArrowAssoc[MatchTreeMaking] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Debugging

### Inherited from MatchCodeGen

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromMatchTreeMaking to any2stringadd[MatchTreeMaking]

### Inherited by implicit conversion StringFormat fromMatchTreeMaking to StringFormat[MatchTreeMaking]

### Inherited by implicit conversion Ensuring fromMatchTreeMaking to Ensuring[MatchTreeMaking]

### Inherited by implicit conversion ArrowAssoc fromMatchTreeMaking to ArrowAssoc[MatchTreeMaking]

### Ungrouped